#pragma once

#include <stddef.h>

#include "mkachook/mkac-dll.h"
#include "mkachook/xinput.h"
#include "mkachook/jvs.h"
#include "board/config.h"

#include "platform/config.h"
#include "gfxhook/config.h"
#include "amcus/config.h"

struct mkac_hook_config {
    struct platform_config platform;
    struct mkac_dll_config dll;
    struct mkac_xinput_config xinput;
    struct gfx_config gfx;
    struct amcus_config amcus;
    struct bpreader_config reader;
};

void mkac_dll_config_load(
    struct mkac_dll_config *cfg,
    const wchar_t *filename);

void mkac_xinput_config_load(
    struct mkac_xinput_config *cfg,
    const wchar_t *filename);

void mkac_hook_config_load(
    struct mkac_hook_config *cfg,
    const wchar_t *filename);

