#pragma once

#include <windows.h>

#include "saoio/saoio.h"

struct sao_dll {
    uint16_t api_version;
    HRESULT (*init)(void);
    HRESULT (*poll)(void);
    void (*read_coin_counter)(uint16_t *coins, uint16_t *services);
    void (*get_opbtns)(uint8_t *opbtn);
    void (*get_drum_analog)(uint8_t *gamebtn);
};

struct sao_dll_config {
    wchar_t path[MAX_PATH];
};

extern struct sao_dll sao_dll;

HRESULT sao_dll_init(const struct sao_dll_config *cfg, HINSTANCE self);
