#include <assert.h>
#include <stddef.h>

#include "tekkenhook/config.h"

#include "platform/config.h"

void tekken_dll_config_load(
        struct tekken_dll_config *cfg,
        const wchar_t *filename)
{
    assert(cfg != NULL);
    assert(filename != NULL);

    GetPrivateProfileStringW(
            L"tekkenio",
            L"path",
            L"",
            cfg->path,
            _countof(cfg->path),
            filename);
}

void tekken_hook_config_load(
        struct tekken_hook_config *cfg,
        const wchar_t *filename)
{
    assert(cfg != NULL);
    assert(filename != NULL);

    platform_config_load(&cfg->platform, filename);
    tekken_dll_config_load(&cfg->dll, filename);
    gfx_config_load(&cfg->gfx, filename);
    bpreader_config_load(&cfg->reader, filename);
}
