#pragma once

#include <windows.h>

#include <stdint.h>

#include "tekkenio/config.h"

enum {
   TEKKEN_IO_OPBTN_TEST = 0x01,
   TEKKEN_IO_OPBTN_SERVICE = 0x02,
};
enum {
   TEKKEN_IO_GAMEBTN_P1_UP = 0x01,
   TEKKEN_IO_GAMEBTN_P1_DOWN = 0x02,
   TEKKEN_IO_GAMEBTN_P1_LEFT = 0x04,
   TEKKEN_IO_GAMEBTN_P1_RIGHT = 0x08,
   TEKKEN_IO_GAMEBTN_P1_START = 0x10,
   TEKKEN_IO_GAMEBTN_P1_BUTTON1 = 0x20,
   TEKKEN_IO_GAMEBTN_P1_BUTTON2 = 0x40,
   TEKKEN_IO_GAMEBTN_P1_BUTTON3 = 0x80,
   TEKKEN_IO_GAMEBTN_P1_BUTTON4 = 0x100,
};
/* Get the version of the Pokken IO API that this DLL supports. This
   function should return a positive 16-bit integer, where the high byte is
   the major version and the low byte is the minor version (as defined by the
   Semantic Versioning standard).

   The latest API version as of this writing is 0x0100. */

uint16_t tekken_io_get_api_version(void);

/* Initialize the IO DLL. This is the second function that will be called on
   your DLL, after tekken_io_get_api_version.

   All subsequent calls to this API may originate from arbitrary threads.

   Minimum API version: 0x0100 */

HRESULT tekken_io_jvs_init(void);

/* Send any queued outputs (of which there are currently none, though this may
   change in subsequent API versions) and retrieve any new inputs.

   Minimum API version: 0x0100 */

HRESULT tekken_io_jvs_poll(uint8_t *opbtn, uint16_t *gamebtn);

void tekken_io_jvs_read_coin_counter(uint16_t *coins);
